PYDOCSTYLE(1)

NAME
pydocstyle - pydocstyle Documentation

(formerly pep257)

pydocstyle is a static analysis tool for checking compliance with Python docstring conventions.

pydocstyle supports most of PEP 257 out of the box, but it should not be considered a reference implementation.

    1.  Install

                    pip install pydocstyle

    2.  Run

                    $ pydocstyle test.py
                    test.py:18 in private nested class `meta`:
                            D101: Docstring missing
                    test.py:22 in public method `method`:
                            D102: Docstring missing
                    ...

    3.  Fix your code :)

Contents:

USAGE

  Installation

Use pip or easy_install:

        pip install pydocstyle

Alternatively, you can use pydocstyle.py source file directly - it is self-contained.

  Command Line Interface

  Usage

        Usage: pydocstyle [options] [<file|dir>...]

        Options:
          --version             show program's version number and exit
          -h, --help            show this help message and exit
          -e, --explain         show explanation of each error
          -s, --source          show source for each error
          -d, --debug           print debug information
          -v, --verbose         print status information
          --count               print total number of errors to stdout
          --select=<codes>      choose the basic list of checked errors by specifying
                                which errors to check for (with a list of comma-
                                separated error codes). for example:
                                --select=D101,D202
          --ignore=<codes>      choose the basic list of checked errors by specifying
                                which errors to ignore (with a list of comma-separated
                                error codes). for example: --ignore=D101,D202
          --convention=<name>   choose the basic list of checked errors by specifying
                                an existing convention. Possible conventions: pep257
          --add-select=<codes>  amend the list of errors to check for by specifying
                                more error codes to check.
          --add-ignore=<codes>  amend the list of errors to check for by specifying
                                more error codes to ignore.
          --match=<pattern>     check only files that exactly match <pattern> regular
                                expression; default is --match='(?!test_).*\.py' which
                                matches files that don't start with 'test_' but end
                                with '.py'
          --match-dir=<pattern>
                                search only dirs that exactly match <pattern> regular
                                expression; default is --match-dir='[^\.].*', which
                                matches all dirs that don't start with a dot

  Return Code
0 | Success - no violations
1 | Some code violations were found
2 | Illegal usage - see error message

  Configuration Files

pydocstyle supports ini-like configuration files. In order for pydocstyle to use it, it must be named one of the following options, and have a [pydocstyle] section.

    •   setup.cfg

    •   tox.ini

    •   .pydocstyle

    •   .pydocstylerc

When searching for a configuration file, pydocstyle looks for one of the file specified above in that exact order. If a configuration file was not found, it keeps looking for one up the directory tree until one is found or uses the default configuration.

NOTE:
        For backwards compatibility purposes, pydocstyle supports configuration files named .pep257, as well as section header [pep257]. However, these are considered deprecated and support will be removed in the next major version.

  Available Options

Not all configuration options are available in the configuration files. Available options are:

    •   convention

    •   select

    •   ignore

    •   add_select

    •   add_ignore

    •   match

    •   match_dir

See the Usage section for more information.

  Inheritance

By default, when finding a configuration file, pydocstyle tries to inherit the parent directory's configuration and merge them to the local ones.

The merge process is as follows:

    •   If one of select, ignore or convention was specified in the child configuration - Ignores the parent configuration and set the new error codes to check. Otherwise, simply copies the parent checked error codes.

    •   If add-ignore or add-select were specified, adds or removes the specified error codes from the checked error codes list.

    •   If match or match-dir were specified - use them. Otherwise, use the parent's.

In order to disable this (useful for configuration files located in your repo's root), simply add inherit=false to your configuration file.

NOTE:
        If any of select, ignore or convention were specified in the CLI, the configuration files will take no part in choosing which error codes will be checked. match and match-dir will still take effect.

  Example

        [pydocstyle]
        inherit = false
        ignore = D100,D203,D405
        match = *.py

ERROR CODES

  Grouping
Missing Docstrings
D100 | Missing docstring in public module
D101 | Missing docstring in public class
D102 | Missing docstring in public method
D103 | Missing docstring in public function
D104 | Missing docstring in public package
D105 | Missing docstring in magic method
Whitespace Issues
D200 | One-line docstring should fit on one line with quotes
D201 | No blank lines allowed before function docstring
D202 | No blank lines allowed after function docstring
D203 | 1 blank line required before class docstring
D204 | 1 blank line required after class docstring
D205 | 1 blank line required between summary line and description
D206 | Docstring should be indented with spaces, not tabs
D207 | Docstring is under-indented
D208 | Docstring is over-indented
D209 | Multi-line docstring closing quotes should be on a separate line
D210 | No whitespaces allowed surrounding docstring text
D211 | No blank lines allowed before class docstring
Quotes Issues
D300 | Use """triple double quotes"""
D301 | Use r""" if any backslashes in a docstring
D302 | Use u""" for Unicode docstrings
Docstring Content Issues
D400 | First line should end with a period
D401 | First line should be in imperative mood
D402 | First line should not be the function's "signature"
D403 | First word of the first line should be properly capitalized

  Default Checks

Not all error codes are checked for by default. The default behavior is to check only error codes that are part of the PEP257 official convention.

All of the above error codes are checked for by default except for D203.

pydocstyle is a rename and continuation of pep257, a project created by Vladimir Keleshev.

Maintained by Amir Rachum.

AUTHOR
Amir Rachum

COPYRIGHT
2016, Amir Rachum